#include <iostream>
#include <fstream>
#include "../random_gen.h"
#include <time.h>
#include <stdio.h>

CRandom NCBIRandom;

inline
double rand01() {

return (double)NCBIRandom.GetRand() / NCBIRandom.GetMax();

}

main(int argc, char **argv)
{
	int snps = atoi(argv[2]);
	int nindiv = atoi(argv[1]);

	double maf = atof(argv[3]);

	cout << "sample=" << nindiv << " snps=" << snps << " maf=" << maf << "\n";
	NCBIRandom.Reset();
	NCBIRandom.SetSeed(time(NULL) + getpid());

	int i,j;
	ofstream map,out;
	map.open("out.map",ios::out);
	out.open("out.ped",ios::out);


	for(j=0; j < snps ; j ++ ) map << "1 snp" << j << " 0 " << j << "\n";


	for(i=0;i< nindiv ; i++) 
	{
		cout << "Generating individual " << i << "\n";

		out << "per" << i << " fam0 0 0 ";
		out << "2 ";
		if(i<nindiv/2) out << "1 "; else out << "2 ";
		

		string s = "";

		for(j=0; j < snps ; j ++ )
		{
			double x = rand01();

			if(x < maf*maf) {
			out << "a a ";
			} else if(x < maf*maf + 2*maf*(1-maf)) {
			out << "a A ";
			} else out << "A A ";

		}

		out << "\n";
			
	
		



	}


	





}